Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
path: root/makechrootpkg.in
diff options
context:
space:
mode:
authorLuke Shumaker <lukeshu@parabola.nu>2017-02-15 15:36:21 -0500
committerLuke Shumaker <lukeshu@parabola.nu>2017-02-19 14:21:29 -0500
commit9b93f4c12d3de7c36f4342e4e764b91ed91231f4 (patch)
treeae7443b9528d0a174fb5a63a07b6db9b31463b8d /makechrootpkg.in
parent8c805dd74b5d29e9994b7fbf7f849a0b6acd29b8 (diff)
makechrootpkg: Have functions be more function-y.
Rather than them simply being named blocks of code with braces around them. That is: have them take things via arguments rather than global variables. Specific notes: - download_sources: Observation: if $SUDO_USER is set, then src_owner=$SUDO_USER. So (for clarity), rather than checking if $SUDO_USER is set, check if $src_owner is different than $USER. This reduces how much we have to worry about global state. - install_packages: 1. Receive the list of packages as arguments, rather than a global variable. 2. Make the caller responsible for looking at PKGBUILD. From the name and arguments, one would never expect it to look at PKGBUILD. - create_chroot->sync_chroot: I pulled the `if [[ ! -d $copydir ]] || $clean_first;` check out; it is now the caller's responsibility to use that check when deciding if to call sync_chroot.
Diffstat (limited to 'makechrootpkg.in')
-rw-r--r--makechrootpkg.in135
1 files changed, 99 insertions, 36 deletions
diff --git a/makechrootpkg.in b/makechrootpkg.in
index e88b6e1..cdc3a93 100644
--- a/makechrootpkg.in
+++ b/makechrootpkg.in
@@ -70,6 +70,14 @@ usage() {
}
# {{{ functions
+# Usage: load_vars $makepkg_conf
+# Globals:
+# - SRCDEST
+# - SRCPKGDEST
+# - PKGDEST
+# - LOGDEST
+# - MAKEFLAGS
+# - PACKAGER
load_vars() {
local makepkg_conf="$1" var
@@ -171,39 +179,56 @@ btrfs_subvolume_delete() {
btrfs subvolume delete "$dir"
}
-create_chroot() {
- # Lock the chroot we want to use. We'll keep this lock until we exit.
- lock 9 "$copydir.lock" "Locking chroot copy [%s]" "$copy"
-
- if [[ ! -d $copydir ]] || $clean_first; then
- # Get a read lock on the root chroot to make
- # sure we don't clone a half-updated chroot
- slock 8 "$chrootdir/root.lock" \
- "Locking clean chroot [%s]" "$chrootdir/root"
-
- stat_busy "Synchronizing chroot copy [%s] -> [%s]" "$chrootdir/root" "$copydir"
- if [[ "$chroottype" == btrfs ]] && ! mountpoint -q "$copydir"; then
- if [[ -d $copydir ]]; then
- btrfs_subvolume_delete "$copydir" >/dev/null ||
- die "Unable to delete subvolume %s" "$copydir"
- fi
- btrfs subvolume snapshot "$chrootdir/root" "$copydir" >/dev/null ||
- die "Unable to create subvolume %s" "$copydir"
- else
- mkdir -p "$copydir"
- rsync -a --delete -q -W -x "$chrootdir/root/" "$copydir"
- fi
- stat_done
+# Usage: sync_chroot $CHROOTDIR/$CHROOT <$CHROOTCOPY|$copydir>
+# Globals:
+# - chroottype
+sync_chroot() {
+ local chrootdir=$1
+ local copy=$2
+ local copydir=''
+ if [[ ${copy:0:1} = / ]]; then
+ copydir=$copy
+ else
+ copydir="$chrootdir/$copy"
+ fi
+
+ if [[ "$chrootdir/root" -ef "$copydir" ]]; then
+ error 'Cannot sync copy with itself: %s' "$copydir"
+ return 1
+ fi
- # Drop the read lock again
- lock_close 8
+ # Get a read lock on the root chroot to make
+ # sure we don't clone a half-updated chroot
+ slock 8 "$chrootdir/root.lock" \
+ "Locking clean chroot [%s]" "$chrootdir/root"
+
+ stat_busy "Synchronizing chroot copy [%s] -> [%s]" "$chrootdir/root" "$copydir"
+ if [[ "$chroottype" == btrfs ]] && ! mountpoint -q "$copydir"; then
+ if [[ -d $copydir ]]; then
+ btrfs_subvolume_delete "$copydir" >/dev/null ||
+ die "Unable to delete subvolume %s" "$copydir"
+ fi
+ btrfs subvolume snapshot "$chrootdir/root" "$copydir" >/dev/null ||
+ die "Unable to create subvolume %s" "$copydir"
+ else
+ mkdir -p "$copydir"
+ rsync -a --delete -q -W -x "$chrootdir/root/" "$copydir"
fi
+ stat_done
+
+ # Drop the read lock again
+ lock_close 8
# Update mtime
touch "$copydir"
}
-clean_temporary() {
+# Usage: delete_chroot $copydir
+# Globals:
+# - chroottype
+delete_chroot() {
+ local copydir=$1
+
stat_busy "Removing chroot copy [%s]" "$copydir"
if [[ "$chroottype" == btrfs ]] && ! mountpoint -q "$copydir"; then
btrfs_subvolume_delete "$copydir" >/dev/null ||
@@ -219,7 +244,11 @@ clean_temporary() {
stat_done
}
+# Usage: install_packages $copydir $pkgs...
install_packages() {
+ local copydir=$1
+ local install_pkgs=("${@:2}")
+
local -a pkgnames
local ret
@@ -231,11 +260,19 @@ install_packages() {
ret=$?
rm -- "${pkgnames[@]/#/$copydir/root/}"
- # If there is no PKGBUILD we are done
- [[ -f PKGBUILD ]] || exit $ret
+ return $ret
}
+# Usage: prepare_chroot $copydir $HOME $repack $run_namcap
+# Globals:
+# - MAKEFLAGS
+# - PACKAGER
prepare_chroot() {
+ local copydir=$1
+ local USER_HOME=$2
+ local repack=$3
+ local run_namcap=$4
+
$repack || rm -rf "$copydir/build"
local builduser_uid="${SUDO_UID:-$UID}"
@@ -301,13 +338,20 @@ _chrootnamcap() {
done
}
+# Usage: download_sources $copydir $src_owner
+# Globals:
+# - SRCDEST
+# - USER
download_sources() {
+ local copydir=$1
+ local src_owner=$2
+
local builddir="$(mktemp -d)"
chmod 1777 "$builddir"
# Ensure sources are downloaded
- if [[ -n $SUDO_USER ]]; then
- sudo -u $SUDO_USER env SRCDEST="$SRCDEST" BUILDDIR="$builddir" \
+ if [[ $USER != $src_owner ]]; then
+ sudo -u $src_owner env SRCDEST="$SRCDEST" BUILDDIR="$builddir" \
makepkg --config="$copydir/etc/makepkg.conf" --verifysource -o
else
( export SRCDEST BUILDDIR="$builddir"
@@ -320,12 +364,21 @@ download_sources() {
rm -rf "$builddir"
}
+# Usage: move_products $copydir $owner
+# Globals:
+# - PKGDEST
+# - LOGDEST
move_products() {
+ local copydir=$1
+ local src_owner=$2
+
+ local pkgfile
for pkgfile in "$copydir"/pkgdest/*; do
chown "$src_owner" "$pkgfile"
mv "$pkgfile" "$PKGDEST"
done
+ local l
for l in "$copydir"/logdest/*; do
[[ $l == */logpipe.* ]] && continue
chown "$src_owner" "$l"
@@ -404,17 +457,27 @@ load_vars /etc/makepkg.conf
[[ -d $SRCPKGDEST ]] || SRCPKGDEST=$PWD
[[ -d $LOGDEST ]] || LOGDEST=$PWD
-create_chroot
+# Lock the chroot we want to use. We'll keep this lock until we exit.
+lock 9 "$copydir.lock" "Locking chroot copy [%s]" "$copy"
+
+if [[ ! -d $copydir ]] || $clean_first; then
+ sync_chroot "$chrootdir" "$copy"
+fi
$update_first && arch-nspawn "$copydir" \
"${bindmounts_ro[@]}" "${bindmounts_rw[@]}" \
pacman -Syu --noconfirm
-[[ -n ${install_pkgs[*]} ]] && install_packages
+if [[ -n ${install_pkgs[*]} ]]; then
+ install_packages "$copydir" "${install_pkgs[@]}"
+ ret=$?
+ # If there is no PKGBUILD we have done
+ [[ -f PKGBUILD ]] || return $ret
+fi
-download_sources
+download_sources "$copydir" "$src_owner"
-prepare_chroot
+prepare_chroot "$copydir" "$USER_HOME" "$repack"
if arch-nspawn "$copydir" \
--bind="$PWD:/startdir" \
@@ -422,12 +485,12 @@ if arch-nspawn "$copydir" \
"${bindmounts_ro[@]}" "${bindmounts_rw[@]}" \
/chrootbuild "${makepkg_args[@]}"
then
- move_products
+ move_products "$copydir" "$src_owner"
else
(( ret += 1 ))
fi
-$temp_chroot && clean_temporary
+$temp_chroot && delete_chroot "$copydir"
if (( ret != 0 )); then
if $temp_chroot; then